package me.km;

import java.util.List;
import me.km.api.GlobalText;
import me.km.items.ItemGun;
import me.km.items.ItemKey;
import me.km.networking.PlayerDisplayGui;
import net.minecraft.item.Item;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.text.TextComponentString;
import net.minecraft.util.text.TextComponentTranslation;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.client.event.ClientChatReceivedEvent;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class ClientEvents 
{   
    @SubscribeEvent
    public void preventChatMessage(ClientChatReceivedEvent e) 
    {
        if(e.getMessage() instanceof TextComponentTranslation)
        {
            TextComponentTranslation trans = (TextComponentTranslation) e.getMessage();
            switch(trans.getKey())
            {
                case "commands.generic.permission":
                {
                    e.setMessage(new TextComponentString("[§5Perms§r] " + GlobalText.noPermission()));
                }
            }   
        }
    }

    @SubscribeEvent
    public void onRenderGui(RenderGameOverlayEvent.Post e)
    {
        if(e.getType() == RenderGameOverlayEvent.ElementType.EXPERIENCE)
        {
            PlayerDisplayGui.INSTANCE.paint();
        }
    }
    
    @SubscribeEvent
    public void showingTooltip(ItemTooltipEvent e) 
    {
        ItemStack stack = e.getItemStack();
        Item item = stack.getItem();
        if(item instanceof ItemArmor)
        {
            NBTTagCompound com = stack.getTagCompound();
            if(com != null && com.hasKey("magic"))
            {
                int magic = com.getInteger("magic");
                if(magic != 0)
                {
                    List<String> list = e.getToolTip();
                    String s = TextFormatting.BLUE + " +";
                    for(int i = 0; i < list.size(); i++)
                    {
                        if(list.get(i).startsWith(s))
                        {
                            list.add(i, TextFormatting.BLUE + " +" + magic + " Magic Armor");
                            break;
                        }
                    }
                }
            }
        }
        else if(item.getClass() == ItemGun.class)
        {
            int load = ItemGun.getLoad(stack);
            if(load >= 0)
            {
                List<String> list = e.getToolTip();
                if(load == 1)
                {
                    list.add(1, TextFormatting.GOLD + "" + load + " shot loaded");
                }
                else
                {
                    list.add(1, TextFormatting.GOLD + "" + load + " shots loaded");
                }
            }
        }
        else if(item.getClass() == ItemKey.class)
        {
            String s = ItemKey.getKey(stack);
            List<String> list = e.getToolTip();
            if(s.isEmpty())
            {
                list.set(0, TextFormatting.RED + list.get(0));
            }
            else
            {
                list.set(0, TextFormatting.GREEN + list.get(0));
            }
        }
    }
}
