package me.km.items;

import me.km.capabilities.ChestKeyProvider;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.common.capabilities.ICapabilityProvider;

public class ItemKey extends ItemBase
{
    private final Item.ToolMaterial toolMaterial;
    
    public ItemKey(String name, String local, Item.ToolMaterial materialIn)
    {
        super(name, local);
        this.toolMaterial = materialIn;
        this.maxStackSize = 1;
    }
    
    public int getLockPickResistance()
    {
        return toolMaterial.getHarvestLevel() + 1;
    }

    @Override
    public ICapabilityProvider initCapabilities(ItemStack stack, NBTTagCompound nbt) 
    {
        getTagCompound(stack);
        return null;
    }  
    
    private static NBTTagCompound getTagCompound(ItemStack stack)
    {
        NBTTagCompound com = stack.getTagCompound();
        if(com == null)
        {
            com = new NBTTagCompound();
            com.setString("chestkey", "");
            com.setBoolean("iscopiedkey", false);
        }
        else 
        {
            if(!com.hasKey("chestkey"))
            {
                com.setString("chestkey", "");  
            }  
            if(!com.hasKey("iscopiedkey"))
            {
                com.setBoolean("iscopiedkey", false);  
            }
        }
        stack.setTagCompound(com);
        return com;
    }
    
    public static String getKey(ItemStack stack)
    {
        return getTagCompound(stack).getString("chestkey");
    }
    
    public static void setKey(ItemStack stack, String key)
    {
        getTagCompound(stack).setString("chestkey", key);
    } 
    
    public static boolean isCopy(ItemStack stack)
    {
        return getTagCompound(stack).getBoolean("iscopiedkey");
    }
    
    public static void setCopy(ItemStack stack, boolean copy)
    {
        getTagCompound(stack).setBoolean("iscopiedkey", copy);
    } 
}
